//
//  UnpinStatusActivity.swift
//  Tusker
//
//  Created by Shadowfacts on 1/4/20.
//  Copyright © 2020 Shadowfacts. All rights reserved.
//

import UIKit
import Pachyderm

class UnpinStatusActivity: StatusActivity {
    override var activityType: UIActivity.ActivityType? {
        return .unpinStatus
    }
    
    override var activityTitle: String? {
        return NSLocalizedString("Unpin", comment: "unpin status activity title")
    }
    
    override var activityImage: UIImage? {
        return UIImage(systemName: "pin.slash")
    }
    
    override func perform() {
        guard let status = status else { return }
        
        let request = Status.unpin(status.id)
        mastodonController.run(request) { (response) in
            if case let .success(status, _) = response {
                self.mastodonController.persistentContainer.addOrUpdate(status: status, incrementReferenceCount: false)
            } else {
                // todo: display error message
                UINotificationFeedbackGenerator().notificationOccurred(.error)
                fatalError()
            }
        }
    }
}
