//
//  ComposeContainerView.swift
//  Tusker
//
//  Created by Shadowfacts on 8/24/20.
//  Copyright © 2020 Shadowfacts. All rights reserved.
//

import SwiftUI
import Combine

struct ComposeContainerView: View {
    let mastodonController: MastodonController
    @ObservedObject var uiState: ComposeUIState
    
    init(
        mastodonController: MastodonController,
        uiState: ComposeUIState
    ) {
        self.mastodonController = mastodonController
        self.uiState = uiState
    }
    
    var body: some View {
        ComposeView(draft: uiState.draft)
        .environmentObject(mastodonController)
        .environmentObject(uiState)
    }
}

//struct ComposeContainerView_Previews: PreviewProvider {
//    static var previews: some View {
//        ComposeContainerView()
//    }
//}
